<!--
 * @Description: 
 * @Author: 王旭
 * @Date: 2023-02-27 11:30:56
 * @LastEditTime: 2023-03-06 15:19:16
 * @LastEditors: 王旭
-->
<template>
  <div class="banner">

    <div class="banner_bg">
      <el-carousel style="height: 100vh;">
        <el-carousel-item v-for="item in carouselOption" :key="item">
          <div class="carouselContent" :class="item.clazz">
          </div>
        </el-carousel-item>
      </el-carousel>
      <div class="carouselLabel">
        <h1>{{ carouselTitle.title }}</h1>
        <h2>{{ carouselTitle.val[0] }}</h2>
        <el-button @click="setMenuClick()" type="primary">在线示例</el-button>
      </div>
    </div>
  </div>
  <div class="content">
    <div class="contentTabs">
      <div class="tabsContent" @click="setMenuTabsClick(item)" v-for="(item, key) in  carouselMenus " :key="key">
        <div class="tabsImg">
          <div>
            <img class="tabsImg" width="98" height="98" :src="require('../assets/img/icon/' + item.img)">
          </div>
        </div>
        <div class="tabsName" :class="{ 'tabsNameCheck': carouselTabsFlag == item.name }">{{ item.name }}</div>

      </div>


    </div>
    <div class="tabsBox">
      <div class="boxTitle">{{ carouselMenusName }}</div>


    </div>
    <div class="tabsImgs">
      <img class="featureImg" :src="require('../assets/img/background/' + carouselMenusFeature)">
    </div>
    <div class="parent" ref="wrapper" id="parent">

      <div class="contentRight">
        <div class="contentRight_l contentRight_l_c" :class="item.className" v-for="( item, i ) in  htmlObj " :key="i"
          v-html="item.html" ref="item"></div>
      </div>
    </div>
  </div>
  <div class="content_bottom">
    <div class="content_bottom_bg"></div>
    <h3 class="content_bottom_title">经典案列</h3>
    <div class="content_bottom_b">
      <div class="content_bottom_b_x">
        <div class="content_bottom_b_c_b">
          <div class="content_bottom_b_c_b1"></div>
        </div>
        <div class="content_bottom_b_c_n">江苏省三维地理信息服务平台建设项目</div>
        <div class="content_bottom_b_c_t">“全景江苏”围绕标准规范建设、数据建设、支撑环境建设、平台软件建设、开发中心建设、示范应用建设进行设计开发，可按需提供三维地理信息弹性云服务</div>
      </div>
      <div class="content_bottom_b_x">
        <div class="content_bottom_b_c_b">
          <div class="content_bottom_b_c_b2"></div>
        </div>
        <div class="content_bottom_b_c_n">上海黄浦区城运中心项目</div>
        <div class="content_bottom_b_c_t">上海黄浦区城运中心项目，以城运中心指挥大厅为载体，通过政务网、公安网、消防指挥网接入，实现各部门“坐席备勤”，提升黄浦综合运营指挥平台的运营和指挥能力</div>
      </div>
      <div class="content_bottom_b_x">
        <div class="content_bottom_b_c_b">
          <div class="content_bottom_b_c_b3"></div>
        </div>
        <div class="content_bottom_b_c_n">天津滨海新区时空信息云平台</div>
        <div class="content_bottom_b_c_t">天津滨海时空信息云平台二期，采用 SmartEarth WebGIS ，围绕“1个大脑”、“4大板块”的智慧滨海建设成果，升级城市运行一张图系统平台</div>
      </div>
    </div>
  </div>
</template>

<script lang="ts" setup>
import {
  ref,
  onMounted,
  onBeforeUnmount,
  reactive,
  defineProps,
  defineEmits,
} from "vue";
import menuTools from '@/assets/js/index.js'
import BScroll from "better-scroll";
import Index from "./Index.vue";
let leftArr = ref(["1", "2", "3", "4"]);
let rightArr = ref([]);
let whichIndex = ref([]);
let rightHeightArr = ref([]);
let rightHeightSumArr = ref([]);
let r = ref([]);
const wrapper = ref(null);
let htmlObj = ref([]);
const carouselOption = ref(null);
const carouselTitle = ref({ title: null, val: [] })
const carouselMenus = ref(null)
const carouselMenusName = ref("")
const carouselMenusFeature = ref('C3D.png')
const carouselTabsFlag = ref("")
const SY = () => {
  window.open("https://cim.smartearth.cn/invite/index.html");
};
function getTwoHeightArr() {
  let item1 = document.getElementsByClassName("contentRight_l_c");

  // item1.forEach((iitem) => {
  //   rightHeightArr.value.push(item["offsetHeight"]);
  // });
  for (let i = 0; i < item1.length; i++) {
    rightHeightArr.value.push(item1[i].offsetHeight);
  }

  let num = 0;
  rightHeightArr.value.forEach((item) => {
    num = num + item;
    rightHeightSumArr.value.push(num);
  });

  // 第三步，有了高度滚动条以后，就可以绑定滚动事件了
  bindScrollEvent();
}
function bindScrollEvent() {
  let wrapper = document.getElementById("parent");

  // 第四步，绑定滚动事件，看滚动到那个区间里面，思路就是通过右侧的区间去同步左侧的区间
  wrapper.onscroll = () => {
    r.value = wrapper.scrollTop;
    // 看看浏览器滚动的高度落到那个区间，在那个区间，就让对应的项高亮
    const scrollWhichIndex = rightHeightSumArr.value.findIndex(
      (item, index) => {
        return (
          r.value >= rightHeightSumArr.value[index] &&
          r.value < rightHeightSumArr.value[index + 1]
        );
      }
    );
    // console.log("所在区间", scrollWhichIndex);
    // 初始的区间为-1，所以还让其为第一项，即索引为0，当用户往下滑动的时候，所以就会
    // 一直大于负一，所以就让其加上一和左侧的高亮项对应。
    if (scrollWhichIndex > -1) {
      whichIndex.value = scrollWhichIndex + 1;
    } else {
      whichIndex.value = 0;
    }
  };
}
// 第五步，当用户点击的时候再让其滚动，因为滚动和高亮是关联的，所以只要控制滚动，就相当于控制高亮。
// 滚动的距离就是，看用户点击的是哪个菜单项的索引，通过索引找到累加数组对应的那一项，
// 也就是滚动的距离。当为第一项的时候边界值要控制一下
function letItemHighLight(i: number) {
  console.log(wrapper.value);
  if (rightHeightSumArr.value[i - 1] == undefined) {
    wrapper.value.scrollTop = 0;
  } else {
    wrapper.value.scrollTop = rightHeightSumArr.value[i - 1];
  }
}
//移动端判断
var isPc = true;

var userAgentInfo = navigator.userAgent; //获取bai游览器请求的用户代理头的值du
var Agents = [
  "Android",
  "iPhone",
  "SymbianOS",
  "Windows Phone",
  "iPad",
  "iPod",
]; //定义移动设备数zhi组
for (var v = 0; v < Agents.length; v++) {
  //判断是否是移动设备
  if (userAgentInfo.indexOf(Agents[v]) > 0) {
    isPc = false;
    break;
  }
}
if (isPc) {

  htmlObj.value = [
    {
      className: "contentRight_l",
      html: "<div class='contentRight_l_rgiht'> <img src='./banner/feature-multidata'></div> </div><div style='clear: both'></div><div class='contentRight_l_left'><h3><span>/</span>海量多源数据融合</h3><p>支持矢量、影像、高程等GIS数据，以及多种格式的三维模型数据（3D瓦片、单体人工模型、语义模型、实例化模型、矢量参数化模型等），实现全要素数字孪生场景的Web端高效渲染。</p><div class='contentRight_num1 contentRight_num'></div></div>",
    },
    {
      className: "contentRight_R",
      html: '<div class="contentRight_l_left"><h3><span>/</span> C3D动态模型服务</h3><p>支持C3D三维模型服务，模型编辑与业务属性动态交互，一次发布，灵活搭建三维场景，提升服务品质。</p><div class="contentRight_num2 contentRight_num"></div></div><div style="clear: both"></div><div class="contentRight_l_rgiht"><img src="./banner/C3D2.png"></div>',
    },
    {
      className: "contentRight_l",
      html: "<div class='contentRight_l_rgiht'> <img src='./banner/cloudmultiaccess2.png'></div><div style='clear: both'></div><div class='contentRight_l_left'><h3><span>/</span>云部署方案</h3><p>云原生部署模式，支持DOCKER、CloudFoundry、Kubernetes等环境，平台功能微服务化，深度集成到用户已有系统，实现服务集群的全生命周期管理。</p><div class='contentRight_num3 contentRight_num'></div></div>",
    },
    {
      className: "contentRight_R",
      html: '<div class="contentRight_l_left"><h3><span>/</span>视频融合</h3><p>以视频流方式融合三维场景，高效易用性强，一个页面同时管理无限数量摄像头。</p><div class="contentRight_num4 contentRight_num"></div></div><div style="clear: both"></div><div class="contentRight_l_rgiht"><img src="./banner/videoIntegration2.png"></div>',
    },
    {
      className: "contentRight_l",
      html: "<div class='contentRight_l_rgiht'> <img src='./banner/nationalized1.png'></div><div style='clear: both'></div><div class='contentRight_l_left'><h3><span>/</span>国产化适配</h3><p>支持Windows64位、各种主流LINUX和UNIX操作系统；适配主流国产CPU、数据库、中间件与操作系统环境，可实现国产化替代零代码一键迁移。</p><div class='contentRight_num3 contentRight_num'></div></div>",
    },
  ];
} else {

  htmlObj.value = [
    {
      className: "contentRight_l",
      html: "<div class='contentRight_l_rgiht'><img src='../assets/img/banner/PWfeature1.png'  alt=''></div><div style='clear: both'></div><div class='contentRight_l_left'><h3><span>/</span>海量多源数据融合</h3><p>免切片，无需轻量化，完整上传BIM模型构件；上传多少加载多少，从此再无性能焦虑。</p><div class='contentRight_num1 contentRight_num'></div></div>",
    },
    {
      className: "contentRight_R",
      html: '<div class="contentRight_l_left"><h3><span>/</span>BIM模型在线编辑</h3><p>前后端同步更新，实时编辑构件信息、属性信息，随时随地修改模型。</p><div class="contentRight_num2 contentRight_num"></div></div><div style="clear: both"></div><div class="contentRight_l_rgiht"><img src="./gif/属性编辑.gif"  alt=""></div>',
    },
    {
      className: "contentRight_l",
      html: "<div class='contentRight_l_rgiht'><img src='./gif/BIM+GIS融合.gif'  alt=''></div><div style='clear: both'></div><div class='contentRight_l_left'><h3><span>/</span>实景三维+BIM数据融合</h3><p>BIM模型不再孤独，建筑信息与环境信息无缝融合，数据世界全要素精准表达。</p><div class='contentRight_num3 contentRight_num'></div></div>",
    },
    {
      className: "contentRight_R",
      html: '<div class="contentRight_l_left"><h3><span>/</span>多方案对比</h3><p>多重方案切换展示，多角度展现产品理念，多元化展现设计思路。</p><div class="contentRight_num4 contentRight_num"></div></div><div style="clear: both"></div><div class="contentRight_l_rgiht"><img src="./gif/方案切换.gif"  alt=""></div>',
    },
  ];
}
const setMenuOptionStart = () => {
  var obj = menuTools.webGisPageData;
  carouselMenus.value = obj.tabs;
  carouselOption.value = obj.img;
  carouselTitle.value = obj.label;
  carouselMenusName.value = carouselMenus.value[0].name;
  carouselTabsFlag.value = carouselMenus.value[0].name;
  carouselMenusFeature.value = carouselMenus.value[0].feature;
}
const setMenuClick = () => {
  var url = menuTools.webGisPageData.url;
  window.open(url)
}
const setMenuTabsClick = (item) => {
  carouselMenusName.value= item.name;
  carouselTabsFlag.value = item.name;
  carouselMenusFeature.value= item.feature;
}
onMounted(() => {
  window.onbeforeunload = function() 
{	
	window.scrollTo(0, 0)

}
  setMenuOptionStart();


});
onBeforeUnmount(() => { });
</script>
<style lang="less" scoped>
.banner {
  width: 100%;
  height: 100vh;
  position: relative;


  .pcimg {
    width: 100%;
    height: 100%;
    position: absolute;
    top: 0;
    left: 0;
    object-fit: cover;
  }

  .banner_bg {
    width: 100%;
    height: 100%;
    position: relative;
    background: rgba(0, 0, 0, 0.4);

    .carouselContent {
      width: 100%;
      height: 100%;
      display: flex;
      justify-content: center
    }

    .carouselLabel {
      width: 100%;
      position: absolute;
      text-align: center;

      h2 {
        margin-bottom: 40px;
      }
    }

    .carousel1 {
      background: url("../assets/img/banner/Web1.jpg") no-repeat;
      background-size: 100% 100%;
    }

    .carousel2 {
      background: url("../assets/img/banner/web2.jpg") no-repeat;
      background-size: 100% 100%;
    }

    .carousel3 {
      background: url("../assets/img/banner/web4.png") no-repeat;
      background-size: 100% 100%;
    }


  }

  .title {
    position: absolute;
    top: 39%;
    left: 200px;

    h3 {
      font-size: 60px;
      font-family: WDCHT;
      color: #ffffff;
      text-shadow: 0px 2px 5px rgba(0, 0, 0, 0.8);
      margin: 0;
      padding-bottom: 10px;
    }

    p {
      font-size: 30px;
      font-family: MicrosoftYaHei;
      color: #ffffff;
      padding-top: 20px;
    }
  }

  .QRcode {
    position: absolute;
    right: 200px;
    bottom: 6%;

    img {
      width: 164px;
      height: 164px;
    }

    .QRcode_title {
      font-size: 18px;
      color: #fff;
      font-weight: bold;
      padding-bottom: 20px;
      text-align: center;
    }
  }
}

.title_btn {
  padding-top: 80px;

  .btn {
    width: 160px;
    height: 44px;
    // background: #6889d8;
    border-radius: 0;
    color: #fff;
    border: 0;
    font-size: 16px;
  }
}

@media (max-width: 1125px) {
  .banner {
    width: 100%;
    height: 360px;
    background: url("../assets/img/index/pic_banner_1beitu.png") no-repeat center;
    background-size: cover;
    cursor: pointer;
  }

  .title_btn {
    padding-top: 10px;
    // .btn {
    //   width: 160px;
    //   height: 44px;
    // }
  }
}

.content {
  width: 1530px;
  margin: 0 auto;
  // height: 600px;
  margin-top: 30px;
  margin-bottom: 160px;
  // padding-left: 200px;
  // padding-right: 200px;
  // box-sizing: border-box;
  position: relative;

  .tabsBox {
    width: 100%;
    height: 100%;
    position: relative;
    margin-top: 10px;

    display: flex;
    justify-content: center;

    .boxTitle {
      width: 100%;
      font-family: -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Arial, sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol";
      font-size: 25px;
      text-align: center;
    }

  }

  .tabsImgs {
    width: 100%;
    height: 100%;
    position: relative;
    margin-top: 10px;
    margin-bottom: 60px;
    display: flex;
    justify-content: center;

    .featureImg {
      width: 800px;
      height: 400px;
    }
  }

  .contentTabs {
    width: 100%;
    height: 100%;
    position: relative;

    display: flex;
    justify-content: center;

    .tabsContent {
      padding: 16px 36px;
      border-bottom: 1px solid #dee2e6;
      padding-bottom: 0px;
    }

    .tabsContent:hover {
      .tabsImg {
        transform: scale(1.1);
      }

      .tabsName {
        border: 1px solid #dee2e6;
        border-bottom: 1px solid white;
        border-top-left-radius: 5px;
        border-top-right-radius: 5px;
      }
    }

    .tabsNameCheck {
      border: 1px solid #dee2e6;
      border-bottom: 1px solid white;
      border-top-left-radius: 5px;
      border-top-right-radius: 5px;
    }

    .tabsName {
      padding: 8px 16px;
      font-size: 14px;
      cursor: pointer;
      font-family: -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Arial, sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol";
    }

    .tabsImg {
      width: 100%;
      display: flex;
      justify-content: center;
      margin-bottom: 8px;
    }
  }

  .parent {
    width: 100%;
    height: 100%;
    display: flex;
    justify-content: center;
    // flex-direction: row-reverse;
    // overflow-y: auto;
    // -ms-overflow-style: none;
    // overflow: -moz-scrollbars-none;
  }

  .contentLeft {
    position: absolute;
    top: 0px;
    left: 0;

    .left_top {
      width: 200px;
      height: 44px;
      background: #192236;
      font-size: 22px;
      font-family: Times-Roman, Times;
      font-weight: normal;
      color: #ffffff;
      text-align: center;
      line-height: 44px;
      margin-bottom: 30px;
    }

    .left_top_title {
      padding-left: 16px;
      font-size: 30px;
      font-family: MicrosoftYaHei-Bold, MicrosoftYaHei;
      font-weight: bold;
      color: #192236;
      margin-bottom: 40px;
    }

    .left_ul {
      padding-left: 50px;

      li {
        width: 20px;
        height: 20px;
        border: 1px solid rgba(25, 34, 54, 0.5);
        border-radius: 50%;
        text-align: center;
        line-height: 20px;
        font-size: 12px;
        font-family: Times-Bold, Times;
        font-weight: bold;
        color: rgba(25, 34, 54, 0.5);
        margin-bottom: 12px;
        cursor: pointer;
      }

      .highLight {
        background: rgba(25, 34, 54, 1);
        color: #fff;
      }

      li:hover {
        background-color: rgba(25, 34, 54, 1);
        color: #fff;
      }
    }
  }

  .contentRight {

    // width: 100%;
    .contentRight_l {
      // width: 100%;
      display: flex;
      // align-items: center;
      // justify-content: space-around;
      flex-direction: row-reverse;
      margin-bottom: 160px;

      .contentRight_l_left {
        width: calc(300px + 100px);
        position: relative;
        margin-right: 60px;

        h3 {
          font-size: 28px;
          font-family: MicrosoftYaHei-Bold, MicrosoftYaHei;
          font-weight: bold;
          color: #192236;
          padding-bottom: 20px;

          span {
            font-size: 26px;
            font-family: MicrosoftYaHei-Bold, MicrosoftYaHei;
            font-weight: bold;
            color: #6889d8;
            padding-right: 10px;
          }
        }

        p {
          font-size: 24px;
          font-family: MicrosoftYaHei;
          color: rgba(25, 34, 54, 0.6);
          text-align: justify;
          text-align-last: auto;
        }

        .contentRight_num1 {
          position: absolute;
          width: 189px;
          height: 344px;
          top: 110px;
          left: 0;
          background: url("../assets/img/index/1.png") no-repeat center;
          background-size: 100% 100%;
        }

        .contentRight_num3 {
          position: absolute;
          width: 189px;
          height: 344px;
          top: 110px;
          left: 0;
          background: url("../assets/img/index/3.png") no-repeat center;
          background-size: 100% 100%;
        }
      }

      .contentRight_l_rgiht {
        width: 908px;
        height: 523px;
        background: url("../assets/img/index/sign_waikuang_da.png") no-repeat center;
        background-size: 100% 100%;
        display: flex;
        align-items: center;
        justify-content: center;

        img {
          width: 880px;
          height: 495px;
        }
      }
    }

    .contentRight_R {
      display: flex;
      // align-items: center;
      // justify-content: space-between;

      flex-direction: row-reverse;
      // margin-bottom: 180px;
      margin-bottom: 160px;

      .contentRight_l_left {
        width: calc(300px + 100px);
        position: relative;
        margin-left: 60px;
        margin-right: 0;

        h3 {
          font-size: 28px;
          font-family: MicrosoftYaHei-Bold, MicrosoftYaHei;
          font-weight: bold;
          color: #192236;
          padding-bottom: 20px;

          span {
            font-size: 26px;
            font-family: MicrosoftYaHei-Bold, MicrosoftYaHei;
            font-weight: bold;
            color: #6889d8;
            padding-right: 10px;
          }
        }

        p {
          font-size: 24px;
          font-family: MicrosoftYaHei;
          color: rgba(25, 34, 54, 0.6);
          text-align: justify;
          text-align-last: auto;
        }

        .contentRight_num2 {
          position: absolute;
          width: 189px;
          height: 344px;
          top: 110px;
          left: 0;
          background: url("../assets/img/index/2.png") no-repeat center;
          background-size: 100% 100%;
        }

        .contentRight_num4 {
          position: absolute;
          width: 189px;
          height: 344px;
          top: 110px;
          left: 0;
          background: url("../assets/img/index/4.png") no-repeat center;
          background-size: 100% 100%;
        }
      }

      .contentRight_l_rgiht {
        width: 908px;
        height: 523px;
        background: url("../assets/img/index/sign_waikuang_da.png") no-repeat center;
        background-size: 100% 100%;
        display: flex;
        align-items: center;
        justify-content: center;

        img {
          width: 880px;
          height: 495px;
        }
      }
    }

    // .contentRight_l:nth-child(2) {
    //   margin-bottom: 0;
    //   padding-bottom: 80px;
    // }
    // .contentRight_l:nth-child(3) {
    //   margin-bottom: 0;
    //   padding-bottom: 80px;
    // }
    .contentRight_R:last-child {
      margin-bottom: 0;
      // padding-bottom: 80px;
    }

    .pcvideo {
      width: 880px;
      height: 495px;
      object-fit: fill;
    }
  }
}

.parent::-webkit-scrollbar {
  width: 0 !important;
}

.content_bottom {
  width: 100%;
  // height: 884px;
  background: rgba(25, 34, 54, 1);
  position: relative;
  padding-bottom: 100px;

  .content_bottom_bg {
    width: 100%;
    position: absolute;
    height: 537px;
    background: url("../assets/img/index/bg_changjing.png") no-repeat center;
    background-size: 100% 100%;
    top: 0;
    left: 0;
    z-index: 0;
  }

  .content_bottom_title {
    position: relative;
    font-size: 36px;
    // font-family: WDCHT;
    color: #ffffff;
    padding-top: 140px;
    text-align: center;
    padding-bottom: 85px;
  }

  .content_bottom_b {
    width: 100%;

    box-sizing: border-box;
    display: flex;
    align-items: center;
    justify-content: space-around;
    flex-wrap: wrap;
  }

  .content_bottom_b_x {
    width: 536px;
  }

  .content_bottom_b_c_b {
    width: 536px;
    height: 312px;
    background: url("../assets/img/index/sign_waikuang_xiao.png") no-repeat center;
    background-size: 100% 100%;
    display: flex;
    align-items: center;
    justify-content: center;

    .content_bottom_b_c_b1 {
      width: 512px;
      height: 288px;
      background: url("../assets/img/banner/websdkcase1.png") no-repeat;
      background-size: 100% 100%;

    }

    .content_bottom_b_c_b2 {
      width: 512px;
      height: 288px;
      background: url("../assets/img/banner/websdkcase2.png") no-repeat;
      background-size: 100% 100%;
    }

    .content_bottom_b_c_b3 {
      width: 512px;
      height: 288px;
      background: url("../assets/img/banner/websdkcase3.png") no-repeat;
      background-size: 100% 100%;
    }
  }

  .content_bottom_b_c_n {
    padding-top: 16px
      /* 16/192 */
    ;
    font-size: 24px;
    font-family: MicrosoftYaHei;
    color: #ffffff;
    text-align: center;
  }
  .content_bottom_b_c_t{
    color: #cdcbcb ;
    font-size: 14px;
    text-align: center;
    margin-top: 10px;
  }
}
</style>
